# TaskQueue

Task queue

#### Introduction

nodejs task queues, a solution for high concurrency peakings of requests, IO operations, or other asynchronous operations

#### Installation Tutorial

1.  pnpm i
2.  pnpm build

#### Debugging Notes

1.pnpm build 2. pnpm example 3. pnpm debug

#### Usage

##### Install dependencies

pnpm install task-queue-lib

import { TaskQueue } from "task-queue-lib";

##### Slice length maxLen

const taskQueue = new TaskQueue({ maxLen: 10 });

##### Create a new queue

`const taskQueue = new TaskQueue({ maxLen: 10 }); `
`taskQueue.push([() => {}])`

##### Functions in a single queue push as many as there are

`taskQueue.push(syncFn.bind(null, "args")); `

##### When all functions in a queue complete, further actions are triggered

`taskQueue.push([() => {}]).then(console.log); // [ undefined ]`
or
`taskQueue.on(taskQueue.defaultKey, console.log).push([() => {}])`

##### Queue index, grouped by the second parameter, asynchronous operations are done in groups

`const fn = (params) => params; `
`taskQueue.push([fn.bind(this, "hello")], "task1"); `
`taskQueue.push([fn.bind(this, "world")], "task1").then(console.log);  // [ 'hello', 'world' ]`
`taskQueue.push([fn.bind(this, "world")], "task2").then(console.log);  // [ 'world' ]`

##### Remove the first three async functions

`taskQueue.unshift(3)`

##### Initializes the current queue

`taskQueue.clearQueue()`
